
/* csg_to_brep.c	87/6/18 */

#include "dsm.h"

struct breps *csg_to_brep(object, sw_csg_op) int object, sw_csg_op;
{
	long	gettme();
	int	i;

	clr_breps(&breps1);

	if (object == 0)
		return(&breps1);

	csg_trav(object, -1.0, STD_MOTION, &breps1);

	if (sw_csg_op) {
		for (i=1; i<=last_csg_ent; i++) {
			if (csg[i].type & (C_UN | C_INT | C_DIF)) {
					fprintf(stderr, "eval...");
				brep_init(csg[csg[i].l_link].brep_ent, csg[csg[i].r_link].brep_ent, &breps1);
#ifdef DIADIC
				brep_distribution(2, csg[csg[i].l_link].brep_ent, &breps1);
				brep_copy(&breps1, &breps2);
#else
				brep_distribution(1, csg[csg[i].l_link].brep_ent, &breps1);
#endif
					fprintf(stderr, ""); restme();
				brep_operation(1, csg[i].type, csg[csg[i].l_link].brep_ent, csg[csg[i].r_link].brep_ent, &breps1);
					fprintf(stderr, "<%1d>", gettme()*10);
#ifdef DIADIC
					fprintf(stderr, ""); restme();
				brep_operation(2, csg[i].type, csg[csg[i].l_link].brep_ent, csg[csg[i].r_link].brep_ent, &breps2);
					fprintf(stderr, "<%1d>", gettme()*10);
				brep_merge(csg[csg[i].l_link].brep_ent, csg[csg[i].r_link].brep_ent, &breps1, &breps2);
#endif
				brep_reconfig(csg[i].type, csg[csg[i].l_link].brep_ent, csg[csg[i].r_link].brep_ent, &breps1);
					fprintf(stderr, "\n");
			}
		}
		return(&breps1);
	}
	else
		return(&breps1);
}
brep_init(l_brep_ent, r_brep_ent, breps)
	int		l_brep_ent, r_brep_ent;
	struct breps	*breps;
{
	if (l_brep_ent == 0 || r_brep_ent == 0)
		return;

	clr_facwork(l_brep_ent, breps);
	clr_facwork(r_brep_ent, breps);
	clr_xedwork(l_brep_ent, breps);
	clr_xedwork(r_brep_ent, breps);
	clr_dpowork(l_brep_ent, breps);
	clr_dpowork(r_brep_ent, breps);
	clr_dvework(l_brep_ent, breps);
	clr_dvework(r_brep_ent, breps);
	clr_pxx(breps);
	clr_exx(breps);
}
brep_distribution(penum, brep_ent, breps)
	int		penum, brep_ent;
	struct breps	*breps;
{
	struct brep		*brep  = breps->brep;
	register struct face	*face  = breps->face;
	register struct xloop	*xloop = breps->xloop;
	register struct xedge	*xedge = breps->xedge;
	register struct brep	*tp_brep;
	register int		fac_ent;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent;
	register int		count;
	int			i,j;

	if (brep_ent == 0)
		return;

	tp_brep = brep+brep_ent;

/*
	for (i=tp_brep->factop, j=tp_brep->factop+tp_brep->facnum/2; i<j; i++) {
		if ((face+i)->xlotop)
			(face+i)->pe = 1;
		else
			(face+i)->pe = 0;
	}
	for (i=tp_brep->factop+tp_brep->facnum/2, j=tp_brep->factop+tp_brep->facnum; i<j; i++) {
		if ((face+i)->xlotop)
			(face+i)->pe = 2;
		else
			(face+i)->pe = 0;
	}
*/

	count = 0;
	for (fac_ent=tp_brep->factop; fac_ent<tp_brep->factop+tp_brep->facnum; fac_ent++) {
		if (cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop) {
			do {
				cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
				do {
					count++;
					if ((xedge+cur_xed_ent)->fa1 == fac_ent)
						cur_xed_ent = (xedge+cur_xed_ent)->link1;
					else
						cur_xed_ent = (xedge+cur_xed_ent)->link2;
				} while (cur_xed_ent != sav_xed_ent);
			} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
			(face+fac_ent)->pe = count*penum/(tp_brep->xednum*2+1)+1;
		}
		else
			(face+fac_ent)->pe = 0;
	}
}
brep_copy(l_breps, r_breps) struct breps *l_breps, *r_breps;
{
	struct brep		*lbrep   = l_breps->brep;
	struct brep		*rbrep   = r_breps->brep;
	struct face		*lface   = l_breps->face;
	struct face		*rface   = r_breps->face;
	struct xloop		*lxloop  = l_breps->xloop;
	struct xloop		*rxloop  = r_breps->xloop;
	register struct xedge	*lxedge  = l_breps->xedge;
	register struct xedge	*rxedge  = r_breps->xedge;
	register struct dpoint	*ldpoint = l_breps->dpoint;
	register struct dpoint	*rdpoint = r_breps->dpoint;
	struct dvect		*ldvect  = l_breps->dvect;
	struct dvect		*rdvect  = r_breps->dvect;
	register int		i;

	if (l_breps == r_breps)
		return;

	r_breps->ls_brep_ent = l_breps->ls_brep_ent;
	r_breps->ls_fac_ent  = l_breps->ls_fac_ent;
	r_breps->ls_xlo_ent  = l_breps->ls_xlo_ent;
	r_breps->ls_xed_ent  = l_breps->ls_xed_ent;
	r_breps->ls_dpo_ent  = l_breps->ls_dpo_ent;
	r_breps->ls_dve_ent  = l_breps->ls_dve_ent;
	r_breps->ls_exx_ent  = l_breps->ls_exx_ent;
	r_breps->ls_pxx_ent  = l_breps->ls_pxx_ent;
	r_breps->fre_xlo_ent = l_breps->fre_xlo_ent;
	r_breps->fre_xed_ent = l_breps->fre_xed_ent;
	r_breps->fre_dpo_ent = l_breps->fre_dpo_ent;
	r_breps->fre_dve_ent = l_breps->fre_dve_ent;

	for (i=1; i<=l_breps->ls_brep_ent; i++)
		*(rbrep+i)   = *(lbrep+i);
	for (i=1; i<=l_breps->ls_fac_ent; i++)
		*(rface+i)   = *(lface+i);
	for (i=1; i<=l_breps->ls_xlo_ent; i++)
		*(rxloop+i)  = *(lxloop+i);
	for (i=1; i<=l_breps->ls_xed_ent; i++)
		*(rxedge+i)  = *(lxedge+i);
	for (i=1; i<=l_breps->ls_dpo_ent; i++)
		*(rdpoint+i) = *(ldpoint+i);
	for (i=1; i<=l_breps->ls_dve_ent; i++)
		*(rdvect+i)  = *(ldvect+i);
}
brep_operation(pe, op, l_brep_ent, r_brep_ent, breps)
	int		pe, op, l_brep_ent, r_brep_ent;
	struct breps	*breps;
{
	struct brep	*brep  = breps->brep;
	struct face	*face  = breps->face;
	struct xloop	*xloop = breps->xloop;
	struct xedge	*xedge = breps->xedge;
	struct brep	*l_brep, *r_brep;
	int 		l_fac_ent, r_fac_ent;
	int 		l_cur_xlo_ent, l_sav_xlo_ent;
	int 		r_cur_xlo_ent, r_sav_xlo_ent;
	int 		l_cur_xed_ent, l_sav_xed_ent;
	int 		r_cur_xed_ent, r_sav_xed_ent;

	if (l_brep_ent == 0 || r_brep_ent == 0)
		return;

	l_brep = brep+l_brep_ent;
	r_brep = brep+r_brep_ent;

/* get crossing points */
	for (l_fac_ent=l_brep->factop; l_fac_ent<l_brep->factop+l_brep->facnum; l_fac_ent++) {
		if ((face+l_fac_ent)->pe == pe) {
			for (r_fac_ent=r_brep->factop; r_fac_ent<r_brep->factop+r_brep->facnum; r_fac_ent++) {
				l_cur_xlo_ent = l_sav_xlo_ent = (face+l_fac_ent)->xlotop;
				do {
					l_cur_xed_ent = l_sav_xed_ent = (xloop+l_cur_xlo_ent)->xedtop;
					do {
						if ((xedge+l_cur_xed_ent)->fa1 == l_fac_ent) {
 							G_f_e_cross(r_fac_ent, l_fac_ent, l_cur_xed_ent, r_brep_ent, l_brep_ent, breps);
							l_cur_xed_ent = (xedge+l_cur_xed_ent)->link1;
						}
						else {
							if ((face+(xedge+l_cur_xed_ent)->fa1)->pe != pe)
 								G_f_e_cross(r_fac_ent, l_fac_ent, l_cur_xed_ent, r_brep_ent, l_brep_ent, breps);
							l_cur_xed_ent = (xedge+l_cur_xed_ent)->link2;
						}
					} while (l_cur_xed_ent != l_sav_xed_ent);
				} while ((l_cur_xlo_ent = (xloop+l_cur_xlo_ent)->r_link) != l_sav_xlo_ent);

				r_cur_xlo_ent = r_sav_xlo_ent = (face+r_fac_ent)->xlotop;
				do {
					r_cur_xed_ent = r_sav_xed_ent = (xloop+r_cur_xlo_ent)->xedtop;
					do {
						if ((xedge+r_cur_xed_ent)->fa1 == r_fac_ent) {
 							G_f_e_cross(l_fac_ent, r_fac_ent, r_cur_xed_ent, l_brep_ent, r_brep_ent, breps);
							r_cur_xed_ent = (xedge+r_cur_xed_ent)->link1;
						}
						else
							r_cur_xed_ent = (xedge+r_cur_xed_ent)->link2;
					} while (r_cur_xed_ent != r_sav_xed_ent);
				} while ((r_cur_xlo_ent = (xloop+r_cur_xlo_ent)->r_link) != r_sav_xlo_ent);
			}
		}
	}

/* get new edges */
	for (l_fac_ent=l_brep->factop; l_fac_ent<l_brep->factop+l_brep->facnum; l_fac_ent++) {
		if ((face+l_fac_ent)->pe == pe) {
			for (r_fac_ent=r_brep->factop; r_fac_ent<r_brep->factop+r_brep->facnum; r_fac_ent++)
				G_f_f_newxed(op, l_fac_ent, r_fac_ent, l_brep_ent, breps);
		}
	}

/* mark */
	breps->pe = pe;
}
brep_merge(l_brep_ent, r_brep_ent, l_breps, r_breps)
	int		l_brep_ent, r_brep_ent;
	struct breps	*l_breps, *r_breps;
{
	struct brep	*rbrep   = r_breps->brep;
	struct face	*lface   = l_breps->face;
	struct face	*rface   = r_breps->face;
	struct xloop	*lxloop  = l_breps->xloop;
	struct xloop	*rxloop  = r_breps->xloop;
	struct xedge	*lxedge  = l_breps->xedge;
	struct xedge	*rxedge  = r_breps->xedge;
	struct brep	*tp_brep;
	int 		fac_ent;
	int 		cur_xlo_ent, sav_xlo_ent;
	int 		l_cur_xed_ent, l_sav_xed_ent;
	int 		r_cur_xed_ent, r_sav_xed_ent;

	if (l_breps == r_breps)
		return;

/* merge R:left_face -> L:left_face */
	tp_brep = rbrep+l_brep_ent;

	for (fac_ent=tp_brep->factop; fac_ent<tp_brep->factop+tp_brep->facnum; fac_ent++) {
		if ((rface+fac_ent)->pe == r_breps->pe) {
			cur_xlo_ent = sav_xlo_ent = (rface+fac_ent)->xlotop;
			do {
				l_cur_xed_ent = l_sav_xed_ent = (lxloop+cur_xlo_ent)->xedtop;
				do {
					if ((lxedge+l_cur_xed_ent)->fa1 == fac_ent) {
						if ((lface+(lxedge+l_cur_xed_ent)->fa2)->pe != l_breps->pe) {
							r_cur_xed_ent = r_sav_xed_ent = (rxloop+cur_xlo_ent)->xedtop;
							do {
								if (G_xed_equ(l_cur_xed_ent, r_cur_xed_ent, l_breps, r_breps))
									G_xed_comp(fac_ent, l_cur_xed_ent, r_cur_xed_ent, l_brep_ent, l_breps, r_breps);
								if ((rxedge+r_cur_xed_ent)->fa1 == fac_ent)
									r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link1;
								else
									r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link2;
							} while (r_cur_xed_ent != r_sav_xed_ent);
						}
						l_cur_xed_ent = (lxedge+l_cur_xed_ent)->link1;
					}
					else {
						if ((lface+(lxedge+l_cur_xed_ent)->fa1)->pe != l_breps->pe && (rface+(lxedge+l_cur_xed_ent)->fa1)->pe != r_breps->pe) {
							r_cur_xed_ent = r_sav_xed_ent = (rxloop+cur_xlo_ent)->xedtop;
							do {
								if (G_xed_equ(l_cur_xed_ent, r_cur_xed_ent, l_breps, r_breps))
									G_xed_comp(fac_ent, l_cur_xed_ent, r_cur_xed_ent, l_brep_ent, l_breps, r_breps);
								if ((rxedge+r_cur_xed_ent)->fa1 == fac_ent)
									r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link1;
								else
									r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link2;
							} while (r_cur_xed_ent != r_sav_xed_ent);
						}
						l_cur_xed_ent = (lxedge+l_cur_xed_ent)->link2;
					}
				} while (l_cur_xed_ent != l_sav_xed_ent);
			} while ((cur_xlo_ent = (lxloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
			G_exx_comp(fac_ent, l_brep_ent, l_breps, r_breps);
		}
	}

/* change fac->pe -> l_breps->pe */
	tp_brep = rbrep+l_brep_ent;

	for (fac_ent=tp_brep->factop; fac_ent<tp_brep->factop+tp_brep->facnum; fac_ent++) {
		if ((rface+fac_ent)->pe == r_breps->pe)
			(lface+fac_ent)->pe = l_breps->pe;
	}

/* merge R:right_face -> L:right_face */
	tp_brep = rbrep+r_brep_ent;

	for (fac_ent=tp_brep->factop; fac_ent<tp_brep->factop+tp_brep->facnum; fac_ent++) {
		cur_xlo_ent = sav_xlo_ent = (rface+fac_ent)->xlotop;
		do {
			l_cur_xed_ent = l_sav_xed_ent = (lxloop+cur_xlo_ent)->xedtop;
			do {
				if ((lxedge+l_cur_xed_ent)->fa1 == fac_ent) {
					r_cur_xed_ent = r_sav_xed_ent = (rxloop+cur_xlo_ent)->xedtop;
					do {
						if (G_xed_equ(l_cur_xed_ent, r_cur_xed_ent, l_breps, r_breps))
 							G_xed_comp(fac_ent, l_cur_xed_ent, r_cur_xed_ent, r_brep_ent, l_breps, r_breps);
						if ((rxedge+r_cur_xed_ent)->fa1 == fac_ent)
							r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link1;
						else
							r_cur_xed_ent = (rxedge+r_cur_xed_ent)->link2;
					} while (r_cur_xed_ent != r_sav_xed_ent);
					l_cur_xed_ent = (lxedge+l_cur_xed_ent)->link1;
				}
				else
					l_cur_xed_ent = (lxedge+l_cur_xed_ent)->link2;
			} while (l_cur_xed_ent != l_sav_xed_ent);
		} while ((cur_xlo_ent = (lxloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
	}
}
brep_reconfig(op, l_brep_ent, r_brep_ent, breps)
	int			op, l_brep_ent, r_brep_ent;
	struct breps		*breps;
{
	struct brep		*brep   = breps->brep;
	struct xedge		*xedge  = breps->xedge;
	register struct dpoint	*dpoint = breps->dpoint;
	register struct dvect	*dvect  = breps->dvect;
	register struct brep	*l_brep, *r_brep;
	double			max();
	double			tp_dbl;
	register int 		com_ent, com2_ent, nxt_com_ent;
	register int		i, j;

	if (l_brep_ent == 0 || r_brep_ent == 0)
		return;

	l_brep = brep+l_brep_ent;
	r_brep = brep+r_brep_ent;

/* invert l_brep (DIF operation) */
	if (op == C_DIF) {
		for (com_ent=l_brep->xedtop, j=l_brep->xednum, i=1; i<=j; i++) {
			G_lxed_invert(com_ent, breps);
			com_ent = (xedge+com_ent)->br_link;
		}
	}

/* invert r_brep (DIF operation) */
	if (op == C_DIF) {
		for (com_ent=r_brep->factop, j=r_brep->factop+r_brep->facnum; com_ent<j; com_ent++)
			G_fac_invert(com_ent, breps);
		for (com_ent=r_brep->xedtop, j=r_brep->xednum, i=1; i<=j; i++) {
			G_rxed_invert(com_ent, breps);
			com_ent = (xedge+com_ent)->br_link;
		}
		for (com_ent=r_brep->dvetop, j=r_brep->dvenum, i=1; i<=j; i++) {
			G_dve_invert(com_ent, breps);
			com_ent = (dvect+com_ent)->br_link;
		}
	}

/* merge two parallel faces */
	for (com_ent=l_brep->factop; com_ent<l_brep->factop+l_brep->facnum; com_ent++) {
		for (com2_ent=r_brep->factop, j=r_brep->factop+r_brep->facnum; com2_ent<j; com2_ent++)
			G_f_f_merge(com_ent, com2_ent, breps);
	}

/* merge two brep */
	G_b_b_merge(l_brep_ent, r_brep_ent, breps);

/* reconfigration of left_faces */
	for (com_ent=l_brep->factop, j=l_brep->factop+l_brep->facnum; com_ent<j; com_ent++)
		G_fac_reconfig(op, com_ent, l_brep_ent, breps);

/* reconfigration of right_faces */
	for (com_ent=r_brep->factop, j=r_brep->factop+r_brep->facnum; com_ent<j; com_ent++)
		G_fac_reconfig(op, com_ent, l_brep_ent, breps);
	l_brep ->facnum += r_brep->facnum;
	r_brep ->facnum = 0;

/* delete one-side-xedge/xloop in face */
	for (com_ent=l_brep->factop, j=l_brep->factop+l_brep->facnum; com_ent<j; com_ent++)
		G_fac_filter(com_ent, l_brep_ent, breps);

/* delete unref xedge */
	for (com_ent=l_brep->xedtop, j=l_brep->xednum, i=1; i<=j; i++) {
		nxt_com_ent = (xedge+com_ent)->br_link;
		G_xed_filter(com_ent, l_brep_ent, breps);
		com_ent = nxt_com_ent;
	}

/* uniq dpoint */
	for (com_ent=l_brep->dpotop, j=l_brep->dponum, i=1; i<=j; i++) {
		G_dpo_proper(com_ent, breps);
		com_ent = (dpoint+com_ent)->br_link;
	}

/* change pointer in face */
	for (com_ent=l_brep->factop, j=l_brep->factop+l_brep->facnum; com_ent<j; com_ent++)
		G_fac_proper(com_ent, breps);

/* change pointer in xedge */
	for (com_ent=l_brep->xedtop, j=l_brep->xednum, i=1; i<=j; i++) {
		G_xed_proper(com_ent, breps);
		com_ent = (xedge+com_ent)->br_link;
	}

/* delete unref dpoint */
	for (com_ent=l_brep->dpotop, j=l_brep->dponum, i=1; i<=j; i++) {
		nxt_com_ent = (dpoint+com_ent)->br_link;
		G_dpo_filter(com_ent, l_brep_ent, breps);
		com_ent = nxt_com_ent;
	}

/* update maxdpo */
	v_len(l_brep->dpocex-r_brep->dpocex, l_brep->dpocey-r_brep->dpocey, l_brep->dpocez-r_brep->dpocez, &tp_dbl);
	l_brep->maxdpo = max(l_brep->maxdpo, tp_dbl+r_brep->maxdpo);
}

