
/* main.c	87/6/24 */

#include "dsm.h"

extern FILE	*yyin;
int		yylineno;

main(argc, argv) int argc; char **argv;
{
#define	CWD_MAX		1024
	struct	stat	stbuf;
	char		*malloc(), *getwd();
	char		*dirname(), *basename();
	int		cwdlen;

	dbmmap();
	restme();

	program_name = malloc(strlen(argv[0])+1);
	strcpy(program_name, argv[0]);

	if (argc != 2) {
		fprintf(stderr, "usage: %s <file> (for help, type 'h' in %s)\n", program_name, program_name);
		exit(1);
	}

	obj_fname = malloc(strlen(argv[1])+1);
	obj_pname = malloc(strlen(argv[1])+2);
	obj_ename = malloc(strlen(argv[1])+3);
	strcpy(obj_fname, argv[1]);
	strcpy(obj_pname, dirname(argv[1]));
	strcat(obj_pname, "#");
	strcat(obj_pname, basename(argv[1]));
	strcpy(obj_ename, dirname(argv[1]));
	strcat(obj_ename, ".@");
	strcat(obj_ename, basename(argv[1]));

	if (*argv[1] == '/') {
		cur_fname = malloc(strlen(argv[1])+1);
		strcpy(cur_fname, argv[1]);
	}
	else {
		cur_wd = getwd();
		cwdlen = strlen(cur_wd);
		cur_fname = malloc(cwdlen+strlen(argv[1])+2);
		strcpy(cur_fname, cur_wd);
		strcat(cur_fname, "/");
		strcat(cur_fname, argv[1]);
	}

     	if (stat(cur_fname, &stbuf)) {
		fprintf(stderr, "\ncan't get status of \"%s\"\n", cur_fname);
		exit(1);
	}

	idtable[0].name   = "$UNDEF";
	idtable[0].f_name = cur_fname;
	ftable[0].name    = ftable[1].name   = cur_fname;
	ftable[0].cwd     = ftable[1].cwd    = dirname(cur_fname);
	ftable[0].st_ino  = ftable[1].st_ino = stbuf.st_ino;
	ftable[0].st_dev  = ftable[1].st_dev = stbuf.st_dev;

	last_file_ent = 1;
	init_mot();
	init_breps();
	init_t();

#ifdef SUNVIEW
	*(argv[1]  ) = '-';
	*(argv[1]+1) = NULL;
	start_view_surface(argv);
#endif
#ifdef SUNX11
	start_xwindow();
#endif

	do {
		rread_count++;
		srand(1);
		cur_file_ent = 1;

		do {
			cur_fname = ftable[cur_file_ent].name;
			cur_wd    = ftable[cur_file_ent].cwd;
     			if (stat(cur_fname, &stbuf)) {
				fprintf(stderr, "\ncan't get status of \"%s\"\n", cur_fname);
				exit(1);
			}
			if (ftable[cur_file_ent].st_time < stbuf.st_mtime) {
				ftable[cur_file_ent].st_time = stbuf.st_mtime;
				if (stbuf.st_mode & S_IEXEC) {
					fprintf(stderr, "[%s]", basename(cur_fname));
					yyin = fopen(cur_fname, "r");
					yylineno = 1;
					y_errline = 0;
					ftable[cur_file_ent].id_ent = 0;
					ftable[cur_file_ent].prim_ent = read_prim(yyin);
					fclose(yyin);
				}
				else {
					fprintf(stderr, "(%s)", basename(cur_fname));
					yyin = fopen(cur_fname, "r");
					yylineno = 1;
					y_errline = 0;
					while (yyparse());
					fclose(yyin);
				}
			}
		} while(cur_file_ent++ < last_file_ent);

		fprintf(stderr, "...end\n");
		if (y_errnum)
			exit(1);
	} while (command());

#ifdef SUNVIEW
        uterminate_view_surface();
#endif

	exit(0);
}

