
/* main.c	87/9/8 */

#include <stdio.h>

main(argc, argv) int argc; char **argv;
{
	FILE		*fp;
	char		fname[32];
	int		fd;
	int		(*mkprim)();
	extern int	mkwed(), mkblo(), mkcyl(), mkcon(), mksph();

	char	*type;
	char	*sssw;
	int	n, ss;
	
	if (argc != 4) {
		fprintf(stderr, "usage: mkprim type n sssw\n");
		fprintf(stderr, "   type : \"WED\",\"BLO\",\"CYL\",\"CON\",\"SPH\"\n");
		fprintf(stderr, "      n : \"3\",\"4\",\"5\"...\n");
		fprintf(stderr, "   sssw : \"sson\",\"ssoff\"\n");
		exit(1);
	}

	type = argv[1];
	if      (strcmp(type, "WED") == 0)
		mkprim = mkwed;
	else if (strcmp(type, "BLO") == 0)
		mkprim = mkblo;
	else if (strcmp(type, "CYL") == 0)
		mkprim = mkcyl;
	else if (strcmp(type, "CON") == 0)
		mkprim = mkcon;
	else if (strcmp(type, "SPH") == 0)
		mkprim = mksph;
	else {
		fprintf(stderr, "type : \"WED\",\"BLO\",\"CYL\",\"CON\",\"SPH\"\n");
		exit(1);
	}

	n = atoi(argv[2]);
	if (n < 3) {
		fprintf(stderr, "n : \"3\",\"4\",\"5\"...\n");
		exit(1);
	}

	sssw = argv[3];
	if      (strcmp(sssw, "sson") == 0)
		ss = 1;
	else if (strcmp(sssw, "ssoff") == 0)
		ss = 0;
	else {
		fprintf(stderr, "sssw : \"sson\",\"ssoff\"\n");
		exit(1);
	}

	sprintf(fname, "%s%1d.%s", type, n, sssw);
	if ((fd = creat(fname, 0555)) < 0) {
		fprintf(stderr, "can't create %s.\n", fname);
		exit(1);
	}
     	else {	
		fp = fdopen(fd, "w");
		mkprim(fp, n, ss);
		close(fp);
		exit(0);
	}
}

